# coding: utf-8

"""
    Velo Payments APIs

    ## Terms and Definitions  Throughout this document and the Velo platform the following terms are used:  * **Payor.** An entity (typically a corporation) which wishes to pay funds to one or more payees via a payout. * **Payee.** The recipient of funds paid out by a payor. * **Payment.** A single transfer of funds from a payor to a payee. * **Payout.** A batch of Payments, typically used by a payor to logically group payments (e.g. by business day). Technically there need be no relationship between the payments in a payout - a single payout can contain payments to multiple payees and/or multiple payments to a single payee. * **Sandbox.** An integration environment provided by Velo Payments which offers a similar API experience to the production environment, but all funding and payment events are simulated, along with many other services such as OFAC sanctions list checking.  ## Overview  The Velo Payments API allows a payor to perform a number of operations. The following is a list of the main capabilities in a natural order of execution:  * Authenticate with the Velo platform * Maintain a collection of payees * Query the payor’s current balance of funds within the platform and perform additional funding * Issue payments to payees * Query the platform for a history of those payments  This document describes the main concepts and APIs required to get up and running with the Velo Payments platform. It is not an exhaustive API reference. For that, please see the separate Velo Payments API Reference.  ## API Considerations  The Velo Payments API is REST based and uses the JSON format for requests and responses.  Most calls are secured using OAuth 2 security and require a valid authentication access token for successful operation. See the Authentication section for details.  Where a dynamic value is required in the examples below, the {token} format is used, suggesting that the caller needs to supply the appropriate value of the token in question (without including the { or } characters).  Where curl examples are given, the –d @filename.json approach is used, indicating that the request body should be placed into a file named filename.json in the current directory. Each of the curl examples in this document should be considered a single line on the command-line, regardless of how they appear in print.  ## Authenticating with the Velo Platform  Once Velo backoffice staff have added your organization as a payor within the Velo platform sandbox, they will create you a payor Id, an API key and an API secret and share these with you in a secure manner.  You will need to use these values to authenticate with the Velo platform in order to gain access to the APIs. The steps to take are explained in the following:  create a string comprising the API key (e.g. 44a9537d-d55d-4b47-8082-14061c2bcdd8) and API secret (e.g. c396b26b-137a-44fd-87f5-34631f8fd529) with a colon between them. E.g. 44a9537d-d55d-4b47-8082-14061c2bcdd8:c396b26b-137a-44fd-87f5-34631f8fd529  base64 encode this string. E.g.: NDRhOTUzN2QtZDU1ZC00YjQ3LTgwODItMTQwNjFjMmJjZGQ4OmMzOTZiMjZiLTEzN2EtNDRmZC04N2Y1LTM0NjMxZjhmZDUyOQ==  create an HTTP **Authorization** header with the value set to e.g. Basic NDRhOTUzN2QtZDU1ZC00YjQ3LTgwODItMTQwNjFjMmJjZGQ4OmMzOTZiMjZiLTEzN2EtNDRmZC04N2Y1LTM0NjMxZjhmZDUyOQ==  perform the Velo authentication REST call using the HTTP header created above e.g. via curl:  ```   curl -X POST \\   -H \"Content-Type: application/json\" \\   -H \"Authorization: Basic NDRhOTUzN2QtZDU1ZC00YjQ3LTgwODItMTQwNjFjMmJjZGQ4OmMzOTZiMjZiLTEzN2EtNDRmZC04N2Y1LTM0NjMxZjhmZDUyOQ==\" \\   'https://api.sandbox.velopayments.com/v1/authenticate?grant_type=client_credentials' ```  If successful, this call will result in a **200** HTTP status code and a response body such as:  ```   {     \"access_token\":\"19f6bafd-93fd-4747-b229-00507bbc991f\",     \"token_type\":\"bearer\",     \"expires_in\":1799,     \"scope\":\"...\"   } ``` ## API access following authentication Following successful authentication, the value of the access_token field in the response (indicated in green above) should then be presented with all subsequent API calls to allow the Velo platform to validate that the caller is authenticated.  This is achieved by setting the HTTP Authorization header with the value set to e.g. Bearer 19f6bafd-93fd-4747-b229-00507bbc991f such as the curl example below:  ```   -H \"Authorization: Bearer 19f6bafd-93fd-4747-b229-00507bbc991f \" ```  If you make other Velo API calls which require authorization but the Authorization header is missing or invalid then you will get a **401** HTTP status response.   # noqa: E501

    The version of the OpenAPI document: 2.20.118
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import velo_payments
from velo_payments.models.query_batch_response2 import QueryBatchResponse2  # noqa: E501
from velo_payments.rest import ApiException

class TestQueryBatchResponse2(unittest.TestCase):
    """QueryBatchResponse2 unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test QueryBatchResponse2
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # model = velo_payments.models.query_batch_response2.QueryBatchResponse2()  # noqa: E501
        if include_optional :
            return QueryBatchResponse2(
                status = 'SUBMITTED', 
                failure_count = 2, 
                pending_count = 2, 
                failures = [
                    {"failedSubmission":{"payorRefs":[{"payorId":"ba08877f-9d96-41e4-9c26-44a872d856ae","invitationStatusTimestamp":"2019-01-20T09:00:00Z","invitationStatus":"ACCEPTED","remoteId":"uniqueIdForRemoteEntity","paymentChannelId":"70faaff7-2c32-4b44-b27f-f0b6c484e6f3"},{"payorId":"ba08877f-9d96-41e4-9c26-44a872d856ae","invitationStatusTimestamp":"2019-01-20T09:00:00Z","invitationStatus":"ACCEPTED","remoteId":"uniqueIdForRemoteEntity","paymentChannelId":"70faaff7-2c32-4b44-b27f-f0b6c484e6f3"}],"country":"US","cellphoneNumber":"1234567890","address":{"country":"US","countyOrProvince":"FL","line4":"line4","city":"Key West","line3":"line3","line2":"line2","line1":"500 Duval St","zipOrPostcode":"33945"},"individual":{"name":{"firstName":"Bob","lastName":"Smith","otherNames":"A","title":"Mr"},"nationalIdentification":"AB123456C","dateOfBirth":"1985-01-01"},"displayName":"Bob","created":"2019-01-20T09:00:00Z","type":"Individual","gracePeriodEndDate":"2019-01-20T00:00:00.000+0000","paymentChannel":{"paymentChannelName":"paymentChannelName","routingNumber":"XXXXX6789","accountName":"My account","countryCode":"US","iban":"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX1234","currency":"USD","accountNumber":"XXXXXX5678"},"remoteId":"remoteId123","marketingOptIns":[{"optedIn":true,"timestamp":"2019-01-20T09:00:00Z"},{"optedIn":true,"timestamp":"2019-01-20T09:00:00Z"}],"watchlistStatusUpdatedTimestamp":"2019-01-20T09:00:00+00:00","challenge":{"description":"challenge description","value":"challenge test"},"company":{"taxId":"123","name":"ABC Ltd","operatingName":"ABC"},"payeeId":"2aa5d7e0-2ecb-403f-8494-1865ed0454e9","email":"bob@example.com","acceptTermsAndConditionsTimestamp":"2019-01-20T09:00:00Z"},"failureMessage":"failure reason"}
                    ]
            )
        else :
            return QueryBatchResponse2(
        )

    def testQueryBatchResponse2(self):
        """Test QueryBatchResponse2"""
        inst_req_only = self.make_instance(include_optional=False)
        inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == '__main__':
    unittest.main()
